/*----- PROTECTED REGION ID(E2SextupoleClass.h) ENABLED START -----*/
/* clang-format on */
//=============================================================================
//
// file :        E2SextupoleClass.h
//
// description : Include for the E2Sextupole root class.
//               This class is the singleton class for
//                the E2Sextupole device class.
//               It contains all properties and methods which the
//               E2Sextupole requires only once e.g. the commands.
//
// project :     Elettra 2.0 pure corrector magnet device
//
// This file is part of Tango device class.
//
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
//
//
// Elettra - Sincrotrone Trieste S.c.p.A.
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef E2SextupoleClass_H
#define E2SextupoleClass_H

#include <tango/tango.h>
#include "E2Sextupole.h"

/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	E2SextupoleClass.h


namespace E2Sextupole_ns
{
/*----- PROTECTED REGION ID(E2SextupoleClass::classes for dynamic creation) ENABLED START -----*/
/* clang-format on */

/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	E2SextupoleClass::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute Strength class definition
class StrengthAttrib: public Tango::Attr
{
public:
	StrengthAttrib():Attr("Strength",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {}
	~StrengthAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<E2Sextupole *>(dev))->read_Strength(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<E2Sextupole *>(dev))->write_Strength(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<E2Sextupole *>(dev))->is_Strength_allowed(ty);}
};

//	Attribute CorrectionStrength class definition
class CorrectionStrengthAttrib: public Tango::Attr
{
public:
	CorrectionStrengthAttrib():Attr("CorrectionStrength",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {}
	~CorrectionStrengthAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<E2Sextupole *>(dev))->read_CorrectionStrength(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<E2Sextupole *>(dev))->write_CorrectionStrength(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<E2Sextupole *>(dev))->is_CorrectionStrength_allowed(ty);}
};

//	Attribute ResonanceStrength class definition
class ResonanceStrengthAttrib: public Tango::Attr
{
public:
	ResonanceStrengthAttrib():Attr("ResonanceStrength",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {}
	~ResonanceStrengthAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<E2Sextupole *>(dev))->read_ResonanceStrength(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<E2Sextupole *>(dev))->write_ResonanceStrength(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<E2Sextupole *>(dev))->is_ResonanceStrength_allowed(ty);}
};

//	Attribute Current class definition
class CurrentAttrib: public Tango::Attr
{
public:
	CurrentAttrib():Attr("Current",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {}
	~CurrentAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<E2Sextupole *>(dev))->read_Current(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<E2Sextupole *>(dev))->write_Current(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<E2Sextupole *>(dev))->is_Current_allowed(ty);}
};

//	Attribute BeamEnergy class definition
class BeamEnergyAttrib: public Tango::Attr
{
public:
	BeamEnergyAttrib():Attr("BeamEnergy",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {}
	~BeamEnergyAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<E2Sextupole *>(dev))->read_BeamEnergy(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<E2Sextupole *>(dev))->write_BeamEnergy(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<E2Sextupole *>(dev))->is_BeamEnergy_allowed(ty);}
};

//	Attribute DesignStrength class definition
class DesignStrengthAttrib: public Tango::Attr
{
public:
	DesignStrengthAttrib():Attr("DesignStrength",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {}
	~DesignStrengthAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<E2Sextupole *>(dev))->read_DesignStrength(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<E2Sextupole *>(dev))->write_DesignStrength(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<E2Sextupole *>(dev))->is_DesignStrength_allowed(ty);}
};

//	Attribute bbaEnable class definition
class bbaEnableAttrib: public Tango::Attr
{
public:
	bbaEnableAttrib():Attr("bbaEnable",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {}
	~bbaEnableAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<E2Sextupole *>(dev))->read_bbaEnable(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<E2Sextupole *>(dev))->write_bbaEnable(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<E2Sextupole *>(dev))->is_bbaEnable_allowed(ty);}
};

//	Attribute ChStrength class definition
class ChStrengthAttrib: public Tango::Attr
{
public:
	ChStrengthAttrib():Attr("ChStrength",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {}
	~ChStrengthAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<E2Sextupole *>(dev))->read_ChStrength(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<E2Sextupole *>(dev))->write_ChStrength(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<E2Sextupole *>(dev))->is_ChStrength_allowed(ty);}
};

//	Attribute ChCorrectionStrength class definition
class ChCorrectionStrengthAttrib: public Tango::Attr
{
public:
	ChCorrectionStrengthAttrib():Attr("ChCorrectionStrength",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {}
	~ChCorrectionStrengthAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<E2Sextupole *>(dev))->read_ChCorrectionStrength(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<E2Sextupole *>(dev))->write_ChCorrectionStrength(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<E2Sextupole *>(dev))->is_ChCorrectionStrength_allowed(ty);}
};

//	Attribute ChResonanceStrength class definition
class ChResonanceStrengthAttrib: public Tango::Attr
{
public:
	ChResonanceStrengthAttrib():Attr("ChResonanceStrength",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {}
	~ChResonanceStrengthAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<E2Sextupole *>(dev))->read_ChResonanceStrength(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<E2Sextupole *>(dev))->write_ChResonanceStrength(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<E2Sextupole *>(dev))->is_ChResonanceStrength_allowed(ty);}
};

//	Attribute CvStrength class definition
class CvStrengthAttrib: public Tango::Attr
{
public:
	CvStrengthAttrib():Attr("CvStrength",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {}
	~CvStrengthAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<E2Sextupole *>(dev))->read_CvStrength(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<E2Sextupole *>(dev))->write_CvStrength(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<E2Sextupole *>(dev))->is_CvStrength_allowed(ty);}
};

//	Attribute CvCorrectionStrength class definition
class CvCorrectionStrengthAttrib: public Tango::Attr
{
public:
	CvCorrectionStrengthAttrib():Attr("CvCorrectionStrength",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {}
	~CvCorrectionStrengthAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<E2Sextupole *>(dev))->read_CvCorrectionStrength(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<E2Sextupole *>(dev))->write_CvCorrectionStrength(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<E2Sextupole *>(dev))->is_CvCorrectionStrength_allowed(ty);}
};

//	Attribute CvResonanceStrength class definition
class CvResonanceStrengthAttrib: public Tango::Attr
{
public:
	CvResonanceStrengthAttrib():Attr("CvResonanceStrength",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {}
	~CvResonanceStrengthAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<E2Sextupole *>(dev))->read_CvResonanceStrength(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<E2Sextupole *>(dev))->write_CvResonanceStrength(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<E2Sextupole *>(dev))->is_CvResonanceStrength_allowed(ty);}
};

//	Attribute SQStrength class definition
class SQStrengthAttrib: public Tango::Attr
{
public:
	SQStrengthAttrib():Attr("SQStrength",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {}
	~SQStrengthAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<E2Sextupole *>(dev))->read_SQStrength(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<E2Sextupole *>(dev))->write_SQStrength(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<E2Sextupole *>(dev))->is_SQStrength_allowed(ty);}
};

//	Attribute SQCorrectionStrength class definition
class SQCorrectionStrengthAttrib: public Tango::Attr
{
public:
	SQCorrectionStrengthAttrib():Attr("SQCorrectionStrength",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {}
	~SQCorrectionStrengthAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<E2Sextupole *>(dev))->read_SQCorrectionStrength(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<E2Sextupole *>(dev))->write_SQCorrectionStrength(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<E2Sextupole *>(dev))->is_SQCorrectionStrength_allowed(ty);}
};

//	Attribute SQResonanceStrength class definition
class SQResonanceStrengthAttrib: public Tango::Attr
{
public:
	SQResonanceStrengthAttrib():Attr("SQResonanceStrength",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {}
	~SQResonanceStrengthAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<E2Sextupole *>(dev))->read_SQResonanceStrength(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<E2Sextupole *>(dev))->write_SQResonanceStrength(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<E2Sextupole *>(dev))->is_SQResonanceStrength_allowed(ty);}
};

//	Attribute CeHCurrent class definition
class CeHCurrentAttrib: public Tango::Attr
{
public:
	CeHCurrentAttrib():Attr("CeHCurrent",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {}
	~CeHCurrentAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<E2Sextupole *>(dev))->read_CeHCurrent(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<E2Sextupole *>(dev))->write_CeHCurrent(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<E2Sextupole *>(dev))->is_CeHCurrent_allowed(ty);}
};

//	Attribute CeVCurrent class definition
class CeVCurrentAttrib: public Tango::Attr
{
public:
	CeVCurrentAttrib():Attr("CeVCurrent",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {}
	~CeVCurrentAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<E2Sextupole *>(dev))->read_CeVCurrent(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<E2Sextupole *>(dev))->write_CeVCurrent(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<E2Sextupole *>(dev))->is_CeVCurrent_allowed(ty);}
};

//	Attribute PolynomA class definition
class PolynomAAttrib: public Tango::SpectrumAttr
{
public:
	// Constants for PolynomA attribute
	constexpr static long X_DATA_SIZE = 3;
	PolynomAAttrib():SpectrumAttr("PolynomA",
			Tango::DEV_DOUBLE, Tango::READ, PolynomAAttrib::X_DATA_SIZE) {}
	~PolynomAAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<E2Sextupole *>(dev))->read_PolynomA(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<E2Sextupole *>(dev))->is_PolynomA_allowed(ty);}
};

//	Attribute PolynomB class definition
class PolynomBAttrib: public Tango::SpectrumAttr
{
public:
	// Constants for PolynomB attribute
	constexpr static long X_DATA_SIZE = 3;
	PolynomBAttrib():SpectrumAttr("PolynomB",
			Tango::DEV_DOUBLE, Tango::READ, PolynomBAttrib::X_DATA_SIZE) {}
	~PolynomBAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<E2Sextupole *>(dev))->read_PolynomB(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<E2Sextupole *>(dev))->is_PolynomB_allowed(ty);}
};


//=========================================
//	Define classes for commands
//=========================================
//	Command Reset class definition
class ResetClass : public Tango::Command
{
public:
	ResetClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	ResetClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~ResetClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<E2Sextupole *>(dev))->is_Reset_allowed(any);}
};

//	Command ResetResonanceStrength class definition
class ResetResonanceStrengthClass : public Tango::Command
{
public:
	ResetResonanceStrengthClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	ResetResonanceStrengthClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~ResetResonanceStrengthClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<E2Sextupole *>(dev))->is_ResetResonanceStrength_allowed(any);}
};

//	Command ApplyDesignStrength class definition
class ApplyDesignStrengthClass : public Tango::Command
{
public:
	ApplyDesignStrengthClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	ApplyDesignStrengthClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~ApplyDesignStrengthClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<E2Sextupole *>(dev))->is_ApplyDesignStrength_allowed(any);}
};


/**
 *	The E2SextupoleClass singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  E2SextupoleClass : public Tango::DeviceClass
#else
class E2SextupoleClass : public Tango::DeviceClass
#endif
{
	/*----- PROTECTED REGION ID(E2SextupoleClass::Additional DServer data members) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2SextupoleClass::Additional DServer data members

	public:
		//	Class properties data members
		//	BeamEnergy:	default electron beam energy, in GeV.
		//  Use to initialize all magnet istances BeamEnergy attribute.
		Tango::DevDouble	beamEnergy;
		//	CalibrationPath:	path of calibration and parameter files
		std::string	calibrationPath;
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
		//	Method prototypes
		static E2SextupoleClass *init(const char *);
		static E2SextupoleClass *instance();
		~E2SextupoleClass();
		Tango::DbDatum	get_class_property(std::string &);
		Tango::DbDatum	get_default_device_property(std::string &);
		Tango::DbDatum	get_default_class_property(std::string &);

	protected:
		E2SextupoleClass(std::string &);
		static E2SextupoleClass *_instance;
		void command_factory();
		void attribute_factory(std::vector<Tango::Attr *> &);
		void pipe_factory();
		void write_class_property();
		void set_default_property();
		void get_class_property();
		std::string get_cvstag();
		std::string get_cvsroot();

	private:
		void device_factory(TANGO_UNUSED(const Tango::DevVarStringArray *));
		void create_static_attribute_list(std::vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,std::vector<Tango::Attr *> &);
		std::vector<std::string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(std::vector<Tango::Attr *> &att_list, std::string attname);
};

}	//	End of namespace

#endif   //	E2Sextupole_H
