/*----- PROTECTED REGION ID(E2SextupoleStateMachine.cpp) ENABLED START -----*/
/* clang-format on */
//=============================================================================
//
// file :        E2SextupoleStateMachine.cpp
//
// description : State machine file for the E2Sextupole class
//
// project :     Elettra 2.0 pure corrector magnet device
//
// This file is part of Tango device class.
//
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
//
//
// Elettra - Sincrotrone Trieste S.c.p.A.
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

#include "E2Sextupole.h"

/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	E2Sextupole::E2SextupoleStateMachine.cpp

//================================================================
//  States   |  Description
//================================================================
//  FAULT    |  at least one connected power supplies in fault
//  INIT     |  initializing system
//  OFF      |  at least one power supply OFF
//  ON       |  power supplies all ON
//  UNKNOWN  |  initialization failed


namespace E2Sextupole_ns
{
//=================================================
//		Attributes Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method     : E2Sextupole::is_Strength_allowed()
 *	Description: Execution allowed for Strength attribute
 */
//--------------------------------------------------------
bool E2Sextupole::is_Strength_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Strength attribute in Write access.
	/*----- PROTECTED REGION ID(E2Sextupole::StrengthStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::StrengthStateAllowed_WRITE

	//	Not any excluded states for Strength attribute in read access.
	/*----- PROTECTED REGION ID(E2Sextupole::StrengthStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::StrengthStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : E2Sextupole::is_CorrectionStrength_allowed()
 *	Description: Execution allowed for CorrectionStrength attribute
 */
//--------------------------------------------------------
bool E2Sextupole::is_CorrectionStrength_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for CorrectionStrength attribute in Write access.
	/*----- PROTECTED REGION ID(E2Sextupole::CorrectionStrengthStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::CorrectionStrengthStateAllowed_WRITE

	//	Not any excluded states for CorrectionStrength attribute in read access.
	/*----- PROTECTED REGION ID(E2Sextupole::CorrectionStrengthStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::CorrectionStrengthStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : E2Sextupole::is_ResonanceStrength_allowed()
 *	Description: Execution allowed for ResonanceStrength attribute
 */
//--------------------------------------------------------
bool E2Sextupole::is_ResonanceStrength_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for ResonanceStrength attribute in Write access.
	/*----- PROTECTED REGION ID(E2Sextupole::ResonanceStrengthStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::ResonanceStrengthStateAllowed_WRITE

	//	Not any excluded states for ResonanceStrength attribute in read access.
	/*----- PROTECTED REGION ID(E2Sextupole::ResonanceStrengthStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::ResonanceStrengthStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : E2Sextupole::is_Current_allowed()
 *	Description: Execution allowed for Current attribute
 */
//--------------------------------------------------------
bool E2Sextupole::is_Current_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Current attribute in Write access.
	/*----- PROTECTED REGION ID(E2Sextupole::CurrentStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::CurrentStateAllowed_WRITE

	//	Not any excluded states for Current attribute in read access.
	/*----- PROTECTED REGION ID(E2Sextupole::CurrentStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::CurrentStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : E2Sextupole::is_BeamEnergy_allowed()
 *	Description: Execution allowed for BeamEnergy attribute
 */
//--------------------------------------------------------
bool E2Sextupole::is_BeamEnergy_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for BeamEnergy attribute in Write access.
	/*----- PROTECTED REGION ID(E2Sextupole::BeamEnergyStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::BeamEnergyStateAllowed_WRITE

	//	Not any excluded states for BeamEnergy attribute in read access.
	/*----- PROTECTED REGION ID(E2Sextupole::BeamEnergyStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::BeamEnergyStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : E2Sextupole::is_DesignStrength_allowed()
 *	Description: Execution allowed for DesignStrength attribute
 */
//--------------------------------------------------------
bool E2Sextupole::is_DesignStrength_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE
		if (get_state()==Tango::FAULT ||
			get_state()==Tango::UNKNOWN ||
			get_state()==Tango::INIT)
		{
		/*----- PROTECTED REGION ID(E2Sextupole::DesignStrengthStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::DesignStrengthStateAllowed_WRITE
			return false;
		}
		return true;
	}
	else

	//	Not any excluded states for DesignStrength attribute in read access.
	/*----- PROTECTED REGION ID(E2Sextupole::DesignStrengthStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::DesignStrengthStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : E2Sextupole::is_bbaEnable_allowed()
 *	Description: Execution allowed for bbaEnable attribute
 */
//--------------------------------------------------------
bool E2Sextupole::is_bbaEnable_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for bbaEnable attribute in Write access.
	/*----- PROTECTED REGION ID(E2Sextupole::bbaEnableStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::bbaEnableStateAllowed_WRITE

	//	Not any excluded states for bbaEnable attribute in read access.
	/*----- PROTECTED REGION ID(E2Sextupole::bbaEnableStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::bbaEnableStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : E2Sextupole::is_ChStrength_allowed()
 *	Description: Execution allowed for ChStrength attribute
 */
//--------------------------------------------------------
bool E2Sextupole::is_ChStrength_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for ChStrength attribute in Write access.
	/*----- PROTECTED REGION ID(E2Sextupole::ChStrengthStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::ChStrengthStateAllowed_WRITE

	//	Not any excluded states for ChStrength attribute in read access.
	/*----- PROTECTED REGION ID(E2Sextupole::ChStrengthStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::ChStrengthStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : E2Sextupole::is_ChCorrectionStrength_allowed()
 *	Description: Execution allowed for ChCorrectionStrength attribute
 */
//--------------------------------------------------------
bool E2Sextupole::is_ChCorrectionStrength_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for ChCorrectionStrength attribute in Write access.
	/*----- PROTECTED REGION ID(E2Sextupole::ChCorrectionStrengthStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::ChCorrectionStrengthStateAllowed_WRITE

	//	Not any excluded states for ChCorrectionStrength attribute in read access.
	/*----- PROTECTED REGION ID(E2Sextupole::ChCorrectionStrengthStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::ChCorrectionStrengthStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : E2Sextupole::is_ChResonanceStrength_allowed()
 *	Description: Execution allowed for ChResonanceStrength attribute
 */
//--------------------------------------------------------
bool E2Sextupole::is_ChResonanceStrength_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for ChResonanceStrength attribute in Write access.
	/*----- PROTECTED REGION ID(E2Sextupole::ChResonanceStrengthStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::ChResonanceStrengthStateAllowed_WRITE

	//	Not any excluded states for ChResonanceStrength attribute in read access.
	/*----- PROTECTED REGION ID(E2Sextupole::ChResonanceStrengthStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::ChResonanceStrengthStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : E2Sextupole::is_CvStrength_allowed()
 *	Description: Execution allowed for CvStrength attribute
 */
//--------------------------------------------------------
bool E2Sextupole::is_CvStrength_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for CvStrength attribute in Write access.
	/*----- PROTECTED REGION ID(E2Sextupole::CvStrengthStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::CvStrengthStateAllowed_WRITE

	//	Not any excluded states for CvStrength attribute in read access.
	/*----- PROTECTED REGION ID(E2Sextupole::CvStrengthStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::CvStrengthStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : E2Sextupole::is_CvCorrectionStrength_allowed()
 *	Description: Execution allowed for CvCorrectionStrength attribute
 */
//--------------------------------------------------------
bool E2Sextupole::is_CvCorrectionStrength_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for CvCorrectionStrength attribute in Write access.
	/*----- PROTECTED REGION ID(E2Sextupole::CvCorrectionStrengthStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::CvCorrectionStrengthStateAllowed_WRITE

	//	Not any excluded states for CvCorrectionStrength attribute in read access.
	/*----- PROTECTED REGION ID(E2Sextupole::CvCorrectionStrengthStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::CvCorrectionStrengthStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : E2Sextupole::is_CvResonanceStrength_allowed()
 *	Description: Execution allowed for CvResonanceStrength attribute
 */
//--------------------------------------------------------
bool E2Sextupole::is_CvResonanceStrength_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for CvResonanceStrength attribute in Write access.
	/*----- PROTECTED REGION ID(E2Sextupole::CvResonanceStrengthStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::CvResonanceStrengthStateAllowed_WRITE

	//	Not any excluded states for CvResonanceStrength attribute in read access.
	/*----- PROTECTED REGION ID(E2Sextupole::CvResonanceStrengthStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::CvResonanceStrengthStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : E2Sextupole::is_SQStrength_allowed()
 *	Description: Execution allowed for SQStrength attribute
 */
//--------------------------------------------------------
bool E2Sextupole::is_SQStrength_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for SQStrength attribute in Write access.
	/*----- PROTECTED REGION ID(E2Sextupole::SQStrengthStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::SQStrengthStateAllowed_WRITE

	//	Not any excluded states for SQStrength attribute in read access.
	/*----- PROTECTED REGION ID(E2Sextupole::SQStrengthStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::SQStrengthStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : E2Sextupole::is_SQCorrectionStrength_allowed()
 *	Description: Execution allowed for SQCorrectionStrength attribute
 */
//--------------------------------------------------------
bool E2Sextupole::is_SQCorrectionStrength_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for SQCorrectionStrength attribute in Write access.
	/*----- PROTECTED REGION ID(E2Sextupole::SQCorrectionStrengthStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::SQCorrectionStrengthStateAllowed_WRITE

	//	Not any excluded states for SQCorrectionStrength attribute in read access.
	/*----- PROTECTED REGION ID(E2Sextupole::SQCorrectionStrengthStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::SQCorrectionStrengthStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : E2Sextupole::is_SQResonanceStrength_allowed()
 *	Description: Execution allowed for SQResonanceStrength attribute
 */
//--------------------------------------------------------
bool E2Sextupole::is_SQResonanceStrength_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for SQResonanceStrength attribute in Write access.
	/*----- PROTECTED REGION ID(E2Sextupole::SQResonanceStrengthStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::SQResonanceStrengthStateAllowed_WRITE

	//	Not any excluded states for SQResonanceStrength attribute in read access.
	/*----- PROTECTED REGION ID(E2Sextupole::SQResonanceStrengthStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::SQResonanceStrengthStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : E2Sextupole::is_CeHCurrent_allowed()
 *	Description: Execution allowed for CeHCurrent attribute
 */
//--------------------------------------------------------
bool E2Sextupole::is_CeHCurrent_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for CeHCurrent attribute in Write access.
	/*----- PROTECTED REGION ID(E2Sextupole::CeHCurrentStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::CeHCurrentStateAllowed_WRITE

	//	Not any excluded states for CeHCurrent attribute in read access.
	/*----- PROTECTED REGION ID(E2Sextupole::CeHCurrentStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::CeHCurrentStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : E2Sextupole::is_CeVCurrent_allowed()
 *	Description: Execution allowed for CeVCurrent attribute
 */
//--------------------------------------------------------
bool E2Sextupole::is_CeVCurrent_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for CeVCurrent attribute in Write access.
	/*----- PROTECTED REGION ID(E2Sextupole::CeVCurrentStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::CeVCurrentStateAllowed_WRITE

	//	Not any excluded states for CeVCurrent attribute in read access.
	/*----- PROTECTED REGION ID(E2Sextupole::CeVCurrentStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::CeVCurrentStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : E2Sextupole::is_PolynomA_allowed()
 *	Description: Execution allowed for PolynomA attribute
 */
//--------------------------------------------------------
bool E2Sextupole::is_PolynomA_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for PolynomA attribute in read access.
	/*----- PROTECTED REGION ID(E2Sextupole::PolynomAStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::PolynomAStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : E2Sextupole::is_PolynomB_allowed()
 *	Description: Execution allowed for PolynomB attribute
 */
//--------------------------------------------------------
bool E2Sextupole::is_PolynomB_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for PolynomB attribute in read access.
	/*----- PROTECTED REGION ID(E2Sextupole::PolynomBStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::PolynomBStateAllowed_READ
	return true;
}


//=================================================
//		Commands Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method     : E2Sextupole::is_Reset_allowed()
 *	Description: Execution allowed for Reset attribute
 */
//--------------------------------------------------------
bool E2Sextupole::is_Reset_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for Reset command.
	/*----- PROTECTED REGION ID(E2Sextupole::ResetStateAllowed) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::ResetStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : E2Sextupole::is_ResetResonanceStrength_allowed()
 *	Description: Execution allowed for ResetResonanceStrength attribute
 */
//--------------------------------------------------------
bool E2Sextupole::is_ResetResonanceStrength_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for ResetResonanceStrength command.
	/*----- PROTECTED REGION ID(E2Sextupole::ResetResonanceStrengthStateAllowed) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::ResetResonanceStrengthStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : E2Sextupole::is_ApplyDesignStrength_allowed()
 *	Description: Execution allowed for ApplyDesignStrength attribute
 */
//--------------------------------------------------------
bool E2Sextupole::is_ApplyDesignStrength_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for ApplyDesignStrength command.
	/*----- PROTECTED REGION ID(E2Sextupole::ApplyDesignStrengthStateAllowed) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	E2Sextupole::ApplyDesignStrengthStateAllowed
	return true;
}


/*----- PROTECTED REGION ID(E2Sextupole::E2SextupoleStateAllowed.AdditionalMethods) ENABLED START -----*/
/* clang-format on */
//	Additional Methods
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	E2Sextupole::E2SextupoleStateAllowed.AdditionalMethods

}	//	End of namespace
